WITH   Gnat.IO ;  USE Gnat.IO;

PROCEDURE   CharTb12  IS

   C_HexCh : String(1..16) := "0123456789ABCDEF" ;

   L_Code : Integer ;

BEGIN
   Put_Line (   "   0123456789ABCDEF"   );
   Put_Line (   "   ----------------"   );

   ----- LOOP 1
   FOR L_i in 0..15 LOOP
      ----- Line address in hexa
      Put (   C_HexCh(L_i+1)   );
      Put (   "0>"   );

      ----- LOOP 2
      FOR L_j in 0..15 LOOP
         L_Code := L_i*16  +  L_j ;

         Put (   Character'Val(L_Code)   );
      END LOOP;--j

      New_Line ;
   END LOOP;--i
END;
